"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Dictionary_1 = require("./Dictionary");
exports.DEFAULT_TAG = '~';
exports.redact = (dictionary, tag, cipher, both) => (line, ...delimiters) => line.split(new RegExp('\\s' + delimiters.map(delim => delim !== ' ' && delim !== '\t' && delim !== '\n' && delim !== '\\s' ? delim : '').join(''))).map(word => both || !dictionary.isEmpty()
    ? dictionary.contains(word)
        ? cipher.encrypt(word)
        : tag !== '' && word.startsWith(tag)
            ? tag + cipher.encrypt(word.substr(tag.length))
            : word
    : !both && dictionary.isEmpty() && tag !== '' && word.startsWith(tag)
        ? tag + cipher.encrypt(word.substr(tag.length))
        : word).join(' ');
exports.expand = (dictionary, tag, cipher, both) => (line) => line.split(' ').map(word => both || !dictionary.isEmpty()
    ? tag !== '' && word.startsWith(tag)
        ? tag + cipher.decrypt(word.substr(tag.length))
        : dictionary.contains(cipher.decrypt(word))
            ? cipher.decrypt(word)
            : word
    : !both && dictionary.isEmpty()
        ? tag !== '' && word.startsWith(tag)
            ? tag + cipher.decrypt(word.substr(tag.length))
            : word
        : word).join(' ');
exports.clean = (tag) => (str) => tag !== ''
    ? str.replace(new RegExp(tag, 'g'), '')
    : str;
exports.Redactor = (dictionary, tag, cipher, both) => ({
    dictionary,
    tag,
    cipher,
    both: both || !dictionary.isEmpty() && tag !== '',
    redact: exports.redact(dictionary, tag, cipher, both),
    expand: exports.expand(dictionary, tag, cipher, both),
    clean: exports.clean(tag)
});
exports.RedactorWithDictionary = (dictionary, cipher) => exports.Redactor(dictionary, '', cipher, false);
exports.RedactorWithTag = (tag, cipher) => exports.Redactor(Dictionary_1.Dictionary([]), tag, cipher, false);
exports.DefaultRedactor = (cipher) => exports.Redactor(Dictionary_1.Dictionary([]), exports.DEFAULT_TAG, cipher, false);
